﻿:Class ZipWeather : MiPage

    :Include #.HTMLInput

    :field Public state←''
    :field Public zip←''
    :field Public Shared States

    ∇ html←Render req;html;form;data;chunk
      :Access Public
      req.Use'JQueryUI'
      html←'h2'Enclose'SQAPL/JQuery Demonstration'
      :If 0∊⍴States
          html,←BRA'h3'Enclose'ZipCodes database is not available!  Sorry...'
      :Else
          chunk←BRA'h3'Enclose'Zip Codes by State'
          form←'Select State: ','state'DropDown States state'autofocus="autofocus" onChange="this.form.submit()"'
          chunk,←'action="#"'('post'Form)form
          :If state≢''
              data←#.SQL.Do'ZipCodes' 'select * from ZipCodes where StateAbbr = :a<C2: order by Zipcode'state
              :If 0=data.ReturnCode
                  chunk,←'style'Enclose'#zips td'Styles'cursor' 'pointer'
                  chunk,←req #.JQO.DataTable'zips'data.(Columns⍪Data)
              :Else
                  chunk←'h3'Enclose'Database query failed? RC = ',⍕data.ReturnCode
              :EndIf
          :EndIf
          html,←chunk
          html,←req #.JQ.On('body' '#zips td')'click'('zip' 'eval' '$(evt.currentTarget).parent().children().first().html()')
      :EndIf
    ∇

    ∇ html←APLJax req;data;Weather;ih;exec;toggle
      :Access public
      html←''
      :If zip≢''
          :If 0≠⊃data←#.ZipWeatherWS.WeatherData zip
              ih←'h4'Enclose'Could not retrieve weather for "',zip,'"<br/>',3⊃data
          :Else
              Weather←Extract 2⊃data
              ih←'div id="tempplot"'Enclose Plot1 Weather
              ih,←'div id="windplot" style="display:none"'Enclose Plot2 Weather
              ih,←'div style="text-align:center"'Enclose Button' Toggle ' 'onclick=$(''#tempplot,#windplot'').toggle();'
              ih←'div'Enclose ih
          :EndIf
          exec←#.JQO.PopupMessage ih('Weather Forecast For ',zip)0 'width:"550px",position:"top"'
          html←#.JSON.fromNVP('execute'exec)
      :EndIf
    ∇

    ∇ Init;data
      :Implements constructor :base
      :Access public
      States←''
      data←#.SQL.Do'ZipCodes' 'select * from States order by StateName'
      :If data.ReturnCode=0
          States←'' ''⍪data.Data
      ⍝ Grab the bits we need from RainPro
          (↑'LineStyle' 'Marker' 'PostScrp' 'ch' 'svg')⎕CY ##.Root,'rainpro'
      :EndIf
    ∇

    ∇ Weather←Extract data
      Weather←⎕NS''
      Weather.(Date Temp Dewpt AppTemp RHum SkyCover WindSpeed WindDir)←↓[1]data
      Weather.Date←cal_ts2ord¨Weather.Date
    ∇

    ∇ html←Plot1 Weather;temps;tn;file
     ⍝ Simple timeseries of various temperature records
      ch.SetHeading'Temperature Series'
      ch.SetStyle'XYPlot'
     
      ch.SetMarginRight 36
     
      ch.SetPenWidths 1.2
      ch.SetLineStyles LineStyle.(Solid Dash Solid)
      ch.SetFillStyles 15
     
      ch.SetXAxisStyle'Date,Grid'
      ch.SetYCaption'Deg C'
      ch.SetYAxisStyle'AtEnd'
      temps←{⎕ML←1 ⋄ ∊⍵}Weather.(Temp AppTemp)
      ch.SetYRange(0⌊¯5+⌊/temps),5+⌈/temps
     
      ch.Plot Weather.(Date Temp AppTemp)
     
      ch.SetMarginTop 220  ⍝ Shorter sec axis!
      ch.Ysec
     
      ch.SetXAxisStyle'Date,nogrid'
      ch.SetYCaption'%'
      ch.SetYAxisStyle'Right,AtEnd,ForceZero,grid'
      ch.SetYRange 0 100
      ch.SetYTickMarks 50
     
      ch.SetBarWidths 0.06 ⍝ Days
      ch.SetBarEdgeNib 0
     
      ch.Xbar Weather.(Date RHum)
     
      ch.SetKeyText'Temperature,Apparent Temperature,Relative Humidity'
      ⎕NUNTIE⊃(tn file)←'svg'#.Files.CreateTemp⊃,/req.Server.(Root TempFolder)
      {}file svg.PS ch.Close
      file←(⍴req.Server.Root)↓file ⍝ relative file name
      html←Tag'embed width="500" src="',file,'" type="image/svg+xml"'
    ∇

    ∇ html←Plot2 Weather;file;tn
      ch.SetMargins 54 36 12 12 ⍝ tblr
     
      ch.SetHeading'Wind Directions and Speeds'
     
      ch.SetMarkers Marker.SmallBullet
     
      ch.SetStyle'XYplot,markers,risers,nolines,Compass'
      ch.SetYAxisStyle'Forcezero,Gridlines'
      ch.SetLabelStyle'opaque'
      ch.SetXTickMarks 45
      ch.Polar Weather.WindDir,[1.5]Weather.WindSpeed
     
      ⎕NUNTIE⊃(tn file)←'svg'#.Files.CreateTemp⊃,/req.Server.(Root TempFolder)
      {}file svg.PS ch.Close
      file←(⍴req.Server.Root)↓file ⍝ relative file name
      html←Tag'embed width="500" src="',file,'" type="image/svg+xml"'
    ∇

    ∇ R←cal_ts2ord TS;DT;M;∆YR;∆MO;ENT;TD;LY;VALID;⎕ML;⎕IO;limit;xl;wdw
⍝ Convert ⎕TS to ordinal days (decimal part is accurate to ~1sec)
⍝ Uses the Excel convention (based 1899 - 1900 IS a leap year)
      ⎕IO←⎕ML←1 ⋄ DT←3↑TS
      LY←(0 0 0 1),400⍴(196⍴1 0 0 0),0 0 0 0
      ∆YR←0,(+\404⍴365)++\LY
      ∆MO←0 31 59 90 120 151 181 212 243 273 304 334 365
      DT[1]←DT[1]-1900
⍝RANGE CHECK ON YR/MTH/DAY
      VALID←DT∧.<400 13 32 ⋄ R←¯1 ⋄ →VALID↓0
⍝ Days in month check fixed .. ↓↓↓↓↓↓↓↓ ... Feb 99 ACDS
      VALID←VALID∧DT[3]≤(LY[1+DT[1]]×2=DT[2])+-/∆MO[13⌊1⌈DT[2]∘.+1 0] ⋄ →VALID↓0
⍝FINALLY ADD UP CUMULATIVE DAYS BASED ON 1900.
      R←∆YR[1⌈DT[1]+1]+∆MO[1⌈DT[2]]+DT[3]
⍝AND ADD ON ONE DAY FOR LEAP-YEARS
      R←R+(DT[2]>2)∧LY[1+DT[1]]
⍝ Now the decimal part
      R←R+0.00001×⌈0.864÷⍨60 60 60⊥TS[4 5 6]
    ∇
:EndClass